#! /bin/sh
#
# find the java executables that are on this machine.
# use the one that's best for our needs.
#
# update these variables with the versions of the runtime that
# are known to work

# initial value
BEST_JAVA_VER=0000
DATE_GENERATED=`date`

JAVA_MIN_VERSION=1040200
JAVA_MAX_VERSION=1050099
LW_AGENT_BIN_DIR=/usr/share/likewise/open-agent/bin

function calc_version
{
   FOO=$(($1*1000000+$2*10000+$3*100+1*$((10#$4))))
}

function keep_best_java_version
{
    A=`echo $4 | sed s/_/./g | sed s/\"//g | sed 's/\./ /g'`
    calc_version $A
    if [[ $FOO -ge $JAVA_MIN_VERSION  &&  $JAVA_VER -le $JAVA_MAX_VERSION ]]; then
	if [ $FOO -gt $BEST_JAVA_VER ]; then
	    BEST_JAVA_BIN=$1
	    BEST_JAVA_VER=$FOO
	    BEST_JAVA_VERSTRING=$4
	fi
    fi
}




# if JRE_HOME is set, assume (perhaps this is bad) that 
# it's pointing at the right jre.

if [ "$JRE_HOME" != '' ]; then 
    foo=`$JRE_HOME/bin/java -version 2>&1`
    keep_best_java_version $JRE_HOME/bin/java $foo    
fi

if [ "$JRE_HOME" = '' ]; then
   JRE_LIKELY_SUSPECTS=`find /usr -name "java" -type f -perm +001 -print`
   # find the jre....
   for javabin in $JRE_LIKELY_SUSPECTS; do
       foo=`$javabin -version 2>&1`
       keep_best_java_version $javabin $foo
   done;
fi
cat <<JREVARSEOF > "$LW_AGENT_BIN_DIR/jrevar.sh"
#! /bin/sh
# this script AUTOMATICALLY GENERATED by findjre.sh
# 
# The best java version found was $BEST_JAVA_VERSTRING
# this script generated on $DATE_GENERATED
export LOA_JRE_BIN="$BEST_JAVA_BIN"
JREVARSEOF


