/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

package com.centeris.webservice.utils;

/**
 * User: rudec
 * Date: Sep 15, 2005
 * Time: 3:01:50 PM
 *
 * Contains the return result of an exec:
 *  - stdout
 *  - stderr
 *  - return code
 */
public class ProcessInfo
{
    protected String stdOut;
    protected String stdErr;
    protected int returnCode;
    protected Exception exception;

    public ProcessInfo(String stdOut, String stdErr, int returnCode, Exception e)
    {
        this.stdOut = stdOut;
        this.stdErr = stdErr;
        this.returnCode = returnCode;
        this.exception = e;
    }

    public ProcessInfo(Exception e)
    {
        this("", "", 0, e);
    }

    public String getStdOut()
    {
        return stdOut;
    }

    public String getStdErr()
    {
        return stdErr;
    }

    public int getReturnCode()
    {
        return returnCode;
    }

    public Exception getException()
    {
        return exception;
    }
}
