/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

package com.centeris.webservice.webinterface;


import java.rmi.Remote;
import java.rmi.RemoteException;
import java.io.*;
import com.centeris.webservice.utils.*;
import com.centeris.webservice.samba.*;

public interface SystemInfoWS extends Remote
{
  public String[] centerisSystemInfo() throws RemoteException;
  

    /**
     * returns the version of centeris code deployed on the server
     * @return
     * @throws RemoteException
     */
  public String likewiseOpenAgentVersion () throws RemoteException, ExecException;
  public String getConfiguredDomain()         throws RemoteException, Exception;
  public String getConfiguredDescription() throws RemoteException, IOException, FileNotFoundException, IniSectionNotFound;
  public String getDeviceTree() throws RemoteException, ExecException;

}
