/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

package com.centeris.webservice.systemmanager;

import junit.framework.TestCase;
import junit.framework.Assert;
import java.rmi.RemoteException;

/**
 * @author aglabek
 * Date: Jul 13, 2005
 */
public class SystemInfoImplWSTest extends TestCase {
    SystemInfoImplWS webService;

    public void setUp()
    {
        webService = new SystemInfoImplWS();
    }

    public void testCenterisSystemInfo() throws RemoteException
    {
        String[] sysInfo = webService.centerisSystemInfo();

        Assert.assertTrue( sysInfo.length == 13 );
        // Centeris version
        Assert.assertTrue( sysInfo[0].length() > new String( "Centeris ").length() );
        // Linux release
        Assert.assertTrue( sysInfo[1].length() > 0 );
        // CPU model
        Assert.assertTrue( sysInfo[8].length() > 0 );
        // CPU speed
        Assert.assertTrue( sysInfo[9].matches( "CPU Speed [0-9].*MHz" ) );
        // Memory ammount
        Assert.assertTrue( sysInfo[10].matches( "^[0-9][0-9][0-9].*Megabytes of RAM") );
    }
}
