/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

package com.centeris.webservice.utils;

import junit.framework.TestCase;
/**
 * Created by IntelliJ IDEA.
 * User: jmannix
 * Date: Jul 11, 2005
 * Time: 10:30:10 PM
 * TODO: all of the rest of this test.   The main code is "covered", but not really.
 */
public class LinuxCommandTest extends TestCase
{
    private static String sBadCommand = "badCommandName";
    public void testBadCommand()
    {
        try
        {
            ExecUtils.runCommand(sBadCommand);
            fail("Should have thrown an exception and not landed here!");
        }
        catch(ExecException ee)
        {
            assertTrue(true);
            System.out.println(ee.toString());
            String stdOut = ee.getStdOut();
            String stdErr = ee.getStdOut();
            int ret = ee.getRetCode();
            assertEquals(-102,ret);
            assertEquals("", stdOut); // shouldn't have had time to get stdOut
            assertEquals("", stdErr); // or stdErr
        }
    }
    public void testNonZeroReturnThrowsException()
    {
        try
        {
            ExecUtils.runCommand("ls nonexistentfilename");
            fail("Should have thrown an exception before getting here");
        }
        catch (ExecException ee)
        {
            assertTrue(true);
            System.out.println("stdOut = " + ee.getStdOut());
            System.out.println("stdErr = " + ee.getStdErr());
            System.out.println("returnCode = " + ee.getRetCode());
        }
    }

}
