/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

package com.centeris.webservice.utils;

import junit.framework.TestCase;

import java.io.IOException;

public class SystemFileLocatorTest extends TestCase {

    public void testSetPropertiesFileLocation01()
            throws IOException
    {
        TestingSystemFileLocator.addOverrideProperties("resources/properties/testing/SystemFileLocatorTest1.properties");

        // the following two values are included in the test properties file and NOT in the default file
        assertEquals(SystemFileLocator.getRelease(), "ReleaseValue");
        assertEquals(SystemFileLocator.getHttpdConf(), "HttpdConfValue");
    }

    public void testSetPropertiesFileLocation02()
            throws IOException
    {
        TestingSystemFileLocator.addOverrideProperties("resources/properties/testing/SystemFileLocatorTest1.properties");

        // the following value is included int he test properties file and overrides a value in the default file
        assertEquals(SystemFileLocator.getLogRoot(), "NewLogRootValue");
    }

    public void tearDown() {
        SystemFileLocator.setPropertiesFileLocation(null);
    }
}
