/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

package com.centeris.webservice.utils;

import java.io.*;
import java.util.Properties;

/**
 * User: rudec
 * Date: Aug 3, 2005
 * Time: 6:29:27 PM
 *
 * Overrides the default SystemFileLocator to add an "override" properties file.
 */
public class TestingSystemFileLocator
        extends SystemFileLocator
{
    /** Only used for testing
     */
    public static void addOverrideProperties(File fileOverrideProperties)
            throws IOException
    {
        Properties overriddenProperties = new Properties(prop);

        if(!fileOverrideProperties.exists()) {
            throw new FileNotFoundException("override properties file " + fileOverrideProperties.getPath() + " does not exist");
        }
        InputStream s = new FileInputStream(fileOverrideProperties);
        overriddenProperties.load(s);
        s.close();

        prop = overriddenProperties;
    }

    public static void addOverrideProperties(String fileOverrideProperties)
            throws IOException
    {
        File file = new File(fileOverrideProperties);
        addOverrideProperties(file);
    }
}
