#
#  spec file for package likewiseopenagt (Version 0.10)
#
#  The contents of this file are subject to the terms of the
#  Common Development and Distribution License, Version 1.0 only
#  (the "License").  You may not use this file except in compliance
#  with the License.
# 
#  You can obtain a copy of the license at 
#  http://www.opensource.org/licenses/cddl1.php
# 
#  When distributing Covered Code, include this CDDL HEADER in each
#  file and include the original License file at src/license.txt.
#  If applicable, add the following below this CDDL HEADER, with the
#  fields enclosed by brackets "[ ]" replaced with your own identifying
#  information: Portions Copyright [yyyy] [name of copyright owner]
# 
#  Copyright (c) 2005,2006 by Centeris, Inc.  All rights reserved.
#  Use is subject to license terms.
#  Initial Developer updates, news, and information may be found at 
#  http://sourceforge.net/projects/likewiseopenagt
#


URL:       http://www.centeris.com
Name:      likewiseopenagt
Group:     System/Management
Summary:   Centeris Likewise Open Agent for OpenSuSE
Version:   %(echo $LIKEWISE_VERSION)
Release:   %(echo $LIKEWISE_RELEASE)
#Epoch:     3
#Copyright: 2005, Centeris Corporation
License: CDDL, Version 1.0

BuildRoot: /tmp/likewise-open-agent-%{version}.%{release}-rpmbuild

Source: http://sourceforge.net/projects/likewiseopenagt/likewise-open-agent-%{version}.%{release}.tar.gz
# TODO: Client binary
#Source1: http://sourceforge.net/projects/likewiseopenagt/likewise-open-agent-%{version}-bin.tar.gz

#
# note that everything betwen samba-winbind and perl-SOAP-Lite are dependencies
# of SOAP-Lite, just in case one has to install from tar.gz
#
Requires: perl-URI >= 1.33, perl-Convert-ASN1 >= 0.18, perl-XML-Parser >= 2.34, samba >= 3.0.20, samba-client >= 3.0.20, samba-winbind >= 3.0.20, perl-libwww-perl,  perl-URI, perl-SOAP-Lite >= 0.66

# TODO: what are the prereqs for building though?  
#Prereq: 
# neededforbuild
#BuildRequires:


# These 2 little variables are incredibly important because they force
# the construction of our rpm in our current directory by pointing
# RPM_BUILD_ROOT to our current directory and having the rpm created
# in our current directory.
#
# mess with them at your peril

%define _sourcedir %(echo $RPM_SRC_DIR)

%define _builddir /tmp

%define _rpmdir   /usr/src/packages/RPMS/

%define man_dir             /usr/share/man
%define lw_bin_dir          /usr/share/likewise/bin
%define lw_perlpm_dir       %{lw_bin_dir}/Centeris
%define lw_agent_dir        /usr/share/likewise/open-agent
%define lw_client_dir       /usr/share/likewise/open-agent/client
%define lw_agent_bin_dir    %{lw_agent_dir}/bin
%define lw_data_dir         /usr/share/centeris/data
%define lw_client_files     %(find ../Windows/Install/LikewiseOpen/bin/?elease/* -type f -printf '/usr/share/likewise/open-agent/client/%f\\n')

%description 
Likewise Open Agent provides Microsoft Windows system administrators an easy way to perform basic administration of Linux servers for file and print using the familiar Microsoft Management Console(MMC) tools/wizards built into Windows.

%prep
%setup -q  -n likewise-open-agent-%{version}.%{release}
pwd

%build

if (! (which ant))
then
	echo 
	echo "Apache ant not found.  Check README for required build utilities";
	exit 1;
fi

cd Linux
cd cesm-agent

# the "all" target in build.xml initializes and compiles the
# entire Likewise Open management suite...
# see build.xml for details.

ant all

%install

cd Linux

LW_BIN_DIR=$RPM_BUILD_ROOT%{lw_bin_dir}
LW_PERLPM_DIR=$RPM_BUILD_ROOT%{lw_perlpm_dir}
LW_AGENT_DIR=$RPM_BUILD_ROOT%{lw_agent_dir}
LW_AGENT_BIN_DIR=$RPM_BUILD_ROOT%{lw_agent_bin_dir}
LW_DATA_DIR=$RPM_BUILD_ROOT%{lw_data_dir}
LW_CLIENT_DIR=$RPM_BUILD_ROOT%{lw_client_dir}
MAN_DIR=$RPM_BUILD_ROOT%{man_dir}

mkdir -p $LW_PERLPM_DIR
mkdir -p $LW_AGENT_BIN_DIR
mkdir -p $LW_AGENT_DIR/log
mkdir -p $LW_CLIENT_DIR
mkdir -p $LW_DATA_DIR/likewise-open
mkdir -p $LW_DATA_DIR/windows/system32
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $MAN_DIR/man7

cp EventLogDB/EventLogs.pm $LW_PERLPM_DIR
cp EventLogDB/evtsyslog.pl $LW_BIN_DIR
cp EventLogDB/dist/likewisemsg.dll $LW_DATA_DIR/windows/system32/likewisemsg.dll
cp EventLogDB/likewise-evtlogd $LW_BIN_DIR
chmod 755 $LW_BIN_DIR/likewise-evtlogd

cp HWInfoFilter/hwinfo_filter.pl $LW_BIN_DIR
chmod 755 $LW_BIN_DIR/hwinfo_filter.pl

cp SambaScripts/shutdown $LW_BIN_DIR
cp SambaScripts/abort_shutdown $LW_BIN_DIR
if [ -e ../Windows/Install/LikewiseOpen/bin/?elease/ ]; then
   cp ../Windows/Install/LikewiseOpen/bin/?elease/* $LW_CLIENT_DIR
fi

chmod 755 $LW_BIN_DIR/shutdown
chmod 755 $LW_BIN_DIR/abort_shutdown 

# note that the ant build step populates the dist directory...

cp ./VERSION $LW_AGENT_BIN_DIR/VERSION

cp cesm-agent/dist/likewise-open-agent.pl $LW_AGENT_BIN_DIR
cp cesm-agent/dist/SambaCommands.jar $LW_AGENT_BIN_DIR
cp cesm-agent/dist/sambaPrint $LW_AGENT_BIN_DIR
cp cesm-agent/dist/sambaShare $LW_AGENT_BIN_DIR
cp cesm-agent/dist/sambaShareInstaller $LW_AGENT_BIN_DIR
chmod 755 $LW_AGENT_BIN_DIR/sambaPrint $LW_AGENT_BIN_DIR/sambaShare $LW_AGENT_BIN_DIR/sambaShareInstaller

cp cesm-agent/dist/likewise-open $RPM_BUILD_ROOT/etc/init.d
cp cesm-agent/dist/likewise-open $LW_BIN_DIR
cp cesm-agent/dist/findjre.sh $LW_AGENT_BIN_DIR
cp cesm-agent/dist/postinstall.sh $LW_BIN_DIR
cp cesm-agent/dist/likewise-perfd $LW_BIN_DIR
# 
gzip -c docs/likewiseopen.7 >$MAN_DIR/man7/likewiseopen.7.gz
%clean

rm -rf  $RPM_BUILD_ROOT
#echo "I would have called 'rm -rf' on $RPM_BUILD_ROOT here, but it doesn't seem to be set"

%files
%defattr(-,root,root,-)
%doc
%dir %{lw_agent_dir}/log
%dir %{lw_agent_bin_dir}
%{lw_perlpm_dir}/EventLogs.pm
%{lw_bin_dir}/evtsyslog.pl
%{lw_bin_dir}/likewise-evtlogd
%{lw_bin_dir}/likewise-perfd
/etc/init.d/likewise-open
%{lw_data_dir}/windows/system32/likewisemsg.dll
# required for our init.d scripts on rhel4, already exists on SuSE

# If the likewise client bits are included, put them in.
%{lw_client_files}
%{lw_bin_dir}/shutdown
%{lw_bin_dir}/abort_shutdown
%{lw_bin_dir}/hwinfo_filter.pl
%{lw_bin_dir}/postinstall.sh
%{lw_bin_dir}/likewise-open
%{lw_agent_bin_dir}/findjre.sh
%{lw_agent_bin_dir}/VERSION
%{lw_agent_bin_dir}/SambaCommands.jar
%{lw_agent_bin_dir}/sambaPrint
%{lw_agent_bin_dir}/sambaShare
%{lw_agent_bin_dir}/sambaShareInstaller
%{lw_agent_bin_dir}/likewise-open-agent.pl
%{man_dir}/man7/likewiseopen.7.gz

### TODO:  Still need all the docs

%changelog
* Tue Jan 24 2006 Brian Moran <info@centeris.com>
- Add manpage support, change tree to /usr/share
- added client bits to server install

* Mon Jan 23 2006 Brian Moran <info@centeris.com>
- re-organized the directories, centralized changes of structures
- changed cesm-agent to open-agent

* Sat Jan 21 2006 Brian Moran <info@centeris.com>
- removed cesm-agent.jar and cesm-agent.war files, fixed some issues in the spec file.

* Wed Nov 30 2005 Jake Mannix <jmannix@centeris.com>
- Corrected some of the Requires: information, corrected some of %files,
- set build paths so it will build on OpenSuSE 10.0

* Wed Nov 23 2005 Jake Mannix <jmannix@centeris.com> 
- Initial build.


