/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

using System;
using System.Net;

namespace Centeris.MMC.DeviceSnapin
{
	/// <summary>
	/// Class that checks SSL certificates for Centeris enabled servers.
	/// </summary>
	public class CenterisCertPolicy: ICertificatePolicy
	{
		public const string CENTERIS_ISSUER = "CN=Centeris Corp., S=Washington, C=US, E=ca_authority@centeris.com, O=Root Certification Authority";

		public CenterisCertPolicy()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		#region ICertificatePolicy Members

		public bool CheckValidationResult(ServicePoint srvPoint, System.Security.Cryptography.X509Certificates.X509Certificate certificate, WebRequest request, int certificateProblem)
		{
			// Check a minimum amount of stuff
			string sIssuer = certificate.GetIssuerName();
			if (sIssuer!=CENTERIS_ISSUER)
				return false;

			return true;
		}

		#endregion
	}
}
