/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

using Ironring.Management.MMC;
using System.Runtime.InteropServices;

namespace Centeris.MMC.PrinterSnapin
{
    /// <summary>
    /// This object describes our root MMC snap-in in the snap-in
    /// picker and the "about" MMC dialog.
    /// </summary>
    [
        Guid(Constants.PRINTERS_ABOUT_CLSID),
        AboutSnapin(typeof(MainClass))
    ]
    public class AboutPrinters : About
    {
        public AboutPrinters()
        {
            Description = "Manage shared printers on your network.";
			Version = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString(4);
			LargeImageName =		"Centeris.MMC.PrinterSnapin.res.wprintfld32.ico";
			SmallClosedImageName =	"Centeris.MMC.PrinterSnapin.res.wprintfld16.ico";
			SmallOpenImageName =	"Centeris.MMC.PrinterSnapin.res.wprintfld16.ico";
			MainIconName =			"Centeris.MMC.PrinterSnapin.res.wprintfld32.ico";
        }
    }
}
