/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

using System;

namespace Centeris.MMC.PrinterSnapin
{
    /// <summary>
    /// Summary description for ExternalConstants.
    /// </summary>
    public class Constants
    {
        /// <summary>
        /// The Node Type GUID of the MMC "Computer Management" node.
        /// </summary>
        protected internal const String
            COMPUTER_MANAGEMENT_NODETYPE = "476e6446-aaff-11d0-b944-00c04fd8d5b0";

        /// <summary>
        /// The GUID of the COM object for the "about" object.
        /// This object describes our root MMC snap-in in the snap-in
        /// picker and the "about" MMC dialog.
        /// </summary>
        protected internal const String
			PRINTERS_ABOUT_CLSID = "B4C967AF-5A30-4901-80D1-420B7F7B11BD";

        /// <summary>
        /// The GUID of the COM object for our root MMC snap-in.
        /// </summary>
        protected internal const String
			PRINTERS_SNAPIN_CLSID = "582AEEFA-1016-4035-9C81-7A44D6A46FB3";

        /// <summary>
        /// Guid of the main "shared folders" extension snap-in.  This
        /// extension has 3 sub-nodes under it:  shares, users, and open files.
        /// </summary>
        protected internal const String
            SHARED_FOLDERS_SNAPIN_GUID = "58221C69-EA27-11CF-ADCF-00AA00A80033";

        protected internal static readonly Guid GuidSharedFolders
            = new Guid(Constants.SHARED_FOLDERS_SNAPIN_GUID);

        /// <summary>
        /// The Node Type GUID of the MMC "System Tools" node.
        /// </summary>
        protected internal const String
            SYSTEM_TOOLS_NODETYPE = "476e6448-aaff-11d0-b944-00c04fd8d5b0";

        protected internal static readonly Guid GuidSystemTools
            = new Guid(Constants.SYSTEM_TOOLS_NODETYPE);

    
        /// <summary>
        /// CLSID of the MSHTML control, as defined in mshtml.idl
        /// todo: is there a way to get this automatically through
        ///       the interop assembly?
        /// </summary>
        protected internal const String
            CLSID_HTMLDOCUMENT = "25336920-03F9-11cf-8FD0-00AA00686F13";

//            WEBBROWSER_CLSID = "8856F961-340A-11D0-A96B-00C04FD705A2";

        protected internal static readonly Guid ClsidWebBrowser
            = new Guid(Constants.CLSID_HTMLDOCUMENT);

    }
}
