@Echo off

rem
rem NOTE - SET THESE ENVIROMENT VARS IN YOUR COMMAND
rem SCRIPT IN USERBUILDENV !!!
rem

set NANT_HOME=---------------SET ME TO SOMETHING----------------
set DEVSTUDIO_HOME=---------------SET ME TO SOMETHING----------------
set LIKEWISE_DIST_PATH=---------------SET ME TO SOMETHING----------------
set PLATFORM_SDK_HOME=---------------SET ME TO SOMETHING----------------


set FRAMEWORK_HOME=%SystemDrive%\WINDOWS\Microsoft.NET\Framework
set FRAMEWORK_VERSION=v1.1.4322

set _NT_SYMBOL_PATH = symsrv*symsrv.dll*%windir%\symbols*http://msdl.microsoft.com/download/symbols

rem ## default window color and title
rem ##

prompt [$T$H$H$H] $P$G
color 17
title Dev Environment

rem ## apply user-specific settings
rem ##
rem ## user-specific settings are stored in a file called:
rem ##     rc-%username%.cmd
rem ##
rem ## use this to customize directories and such with your personal
rem ## paths, and any other desired settings.

if exist userbuildenv\%USERNAME%\rc-%USERNAME%.cmd (call userbuildenv\%USERNAME%\rc-%USERNAME%.cmd)

rem ## VERIFY THAT ALL DIRECTORIES EXIST
rem ##
for %%i in (NANT_HOME DEVSTUDIO_HOME PLATFORM_SDK_HOME FRAMEWORK_HOME) do call :verifyPath %%i

rem ## SET THE INITIAL PATH
rem ##

set PATH=%PATH%;%NANT_HOME%\bin
set PATH=%PATH%;%DEVSTUDIO_HOME%\Common7\Tools\Bin
set PATH=%PATH%;%DEVSTUDIO_HOME%\Common7\IDE
set PATH=%PATH%;%DEVSTUDIO_HOME%\Vc7\bin
set PATH=%PATH%;%DEVSTUDIO_HOME%\SDK\v1.1\Bin
set PATH=%PATH%;%FRAMEWORK_HOME%\%FRAMEWORK_VERSION%

rem ##### EXPLANATION OF SETTINGS TO FOLLOW #####
rem ##
rem ##  We need to have the environment variables for the compiler suite
rem ##  (INCLUDE, LIB, and PATH) reference both the "Platform SDK" and
rem ##  the "Visual Studio .NET 2003"  directories.
rem ##
rem ##  The "Platform SDK" directories need to come first.
rem ##
rem ##  Both products have .bat files which make changes to these dirs
rem ##  by inserting their favorite directories at the beginning of
rem ##  (INCLUDE, LIB, and PATH), leaving the value it was previously
rem ##  defined to at the end.
rem ##
rem ##  So, if we call both batch files, but call the SDK one second,
rem ##  everything should be fine, right?
rem ##

pushd %DEVSTUDIO_HOME%\Common7\Tools
call vsvars32.bat
popd

pushd %PLATFORM_SDK_HOME%
call setenv.bat /XP32 /RETAIL
popd

rem ## dump all the relevant environment variables to the screen
rem ##

for %%i in (NANT_HOME PLATFORM_SDK_HOME DEVSTUDIO_HOME MSSdk Mstools INCLUDE LIB PATH) do set %%i

goto :eof

:verifyPath
for /f "tokens=2 delims==" %%x in ('set %1') do set y=%%x
if not exist "%y%" echo *** ERROR: directory not found. %1 = %y%
if not exist "%y%" pause

goto :eof
