#undef REGISTRATIONDIALOGS

using System;
using System.Reflection;
using System.Collections;
using System.Runtime.InteropServices;
using Microsoft.Win32;


#if REGISTRATIONDIALOGS
using wf=System.Windows.Forms;
#endif

namespace Ironring.Management.MMC
{
	class SnapinRegistrar
	{
		public static void Register()
		{

#if REGISTRATIONDIALOGS
			// TODO: REMOVE
 			wf.MessageBox.Show("In SnapinRegistrar.Register");
#endif
			
			// ok start the big hunt
			foreach (Assembly a in AppDomain.CurrentDomain.GetAssemblies())
				Register(a);
		}
		public static void Register(Assembly a)
		{
#if REGISTRATIONDIALOGS
			wf.MessageBox.Show("In SnapinRegistrar.Register(Assembly)");
#endif
			SnapReg reg = new SnapReg();
			reg.Register(a);
		}
			
		public static void UnRegister()
		{
			// ok start the big hunt
			foreach (Assembly a in AppDomain.CurrentDomain.GetAssemblies())
				UnRegister(a);
		}

		public static void UnRegister(Assembly a)
		{
			SnapReg reg = new SnapReg();
			reg.UnRegister(a);
		}
	}

    class SnapinRegInfo
    {
        public SnapinRegInfo()
        {
        }

        public Type fSnapinType;
        public string fGUID;
        public SnapinInAttribute fAttrib;
        public SnapinAboutRegistration fAboutReg;
        public NodeTypeGuidAttribute[] aryNodeTypes;
		public ExtendsNodeAttribute[] aryExtendNodeTypes;
    }


    class SnapinAboutRegistration
    {
        public SnapinAboutRegistration()
        {
        }

        public string fGUID;
        public AboutSnapinAttribute fAboutAttrib;
    }
    
    /// <summary>
	/// Summary description for SnapReg
	/// </summary>
	class SnapReg
	{
        ArrayList fSnapinRegInfos = new ArrayList();
        Hashtable fSnapinAboutRegistrations = new Hashtable();

		public void UnRegister(Assembly asm)
		{
			foreach(Type t in asm.GetTypes())
			{
				// must meet these requirements
				if (Marshal.IsTypeVisibleFromCom(t) && t.IsClass && (t.IsPublic || t.IsNestedPublic) && !t.IsImport)
					FindAttributes(t);
			}

			PrepareAttribute();

			UnRegister();
		}

        /// <summary>
        /// Register all snapins in the assemply
        /// </summary>
        /// <param name="asm">the assembly to register</param>
        public void Register(Assembly asm)
        {
#if REGISTRATIONDIALOGS
			wf.MessageBox.Show("In SnapReg.Register(Assembly)");
#endif
			foreach(Type t in asm.GetTypes())
            {
                // must meet these requirements
                if (Marshal.IsTypeVisibleFromCom(t) && t.IsClass && (t.IsPublic || t.IsNestedPublic) && !t.IsImport)
                    FindAttributes(t);
            }

			PrepareAttribute();

			Register();
        }


        /// <summary>
        /// Register this type if it looks like it should be registered!
        /// </summary>
        /// <param name="t">the type</param>
        void FindAttributes(Type t)
        {
			// Creatable class - get Guid and ProgId
            string strClsId = "{" + Marshal.GenerateGuidForType(t).ToString().ToUpper() + "}";

            //////////////////////////////////////////////////////
            // Found a Snapin itself!

            object [] attribs = t.GetCustomAttributes(typeof(SnapinInAttribute), true);
            if (attribs.Length != 0) 
            {
                SnapinInAttribute snapinAttrib = attribs[0] as SnapinInAttribute;
                if (snapinAttrib != null)
                {
                    SnapinRegInfo snapReg = new SnapinRegInfo();
                    
                    snapReg.fAttrib = snapinAttrib;
                    snapReg.fGUID = strClsId.ToUpper();
                    snapReg.fSnapinType = t;
                    fSnapinRegInfos.Add(snapReg);

                    // find all the "NodeTypeGuid" attributes on this same object.
                    // They represent all of the well-known node types that can be
                    // created by this snap-in.
                    // Remember all the attributes that we find so that we can
                    // add them to the registry later.
                    snapReg.aryNodeTypes =
                            t.GetCustomAttributes(typeof(NodeTypeGuidAttribute), true)
                                as NodeTypeGuidAttribute[];

					// ind all the "ExtendsSnapin" attributes on this same object.
					// They represent all of the well-known node types that this
					// snapin can extend.
					// Remember all the attributes that we find so that we can 
					// add them to the registry later.
					snapReg.aryExtendNodeTypes =
							t.GetCustomAttributes(typeof(ExtendsNodeAttribute), true)
								as ExtendsNodeAttribute[];
                }
            }


            //////////////////////////////////////////////////////
            // Found a Snapin About class

            attribs = t.GetCustomAttributes(typeof(AboutSnapinAttribute), true);
            if (attribs.Length != 0) 
            {
                // List the guid from the snapin we are associated with via the AboutSnapinAttribute

                AboutSnapinAttribute aboutAttrib = attribs[0] as AboutSnapinAttribute;
                if (aboutAttrib != null)
                {
                    SnapinAboutRegistration AboutReg = new SnapinAboutRegistration();
                    AboutReg.fAboutAttrib = aboutAttrib;
                    AboutReg.fGUID = strClsId.ToUpper();
                    fSnapinAboutRegistrations.Add(aboutAttrib.SnapinType.ToString(), AboutReg);
                }
            }
        }

        //match up the snapin with the snapin abouts
        void PrepareAttribute()
        {
			foreach(SnapinRegInfo snapin in fSnapinRegInfos)
            {            
				SnapinAboutRegistration aboutReg = fSnapinAboutRegistrations[snapin.fSnapinType.ToString()] as SnapinAboutRegistration;
				if (aboutReg == null)
					throw new ApplicationException("Failed to locate a Snapin About object for the snapin: " + snapin.fSnapinType.ToString());

                snapin.fAboutReg = aboutReg;
            }
        }

        // we have all the data and its valid so go ahead and run it into the registry
        void Register()
        {
#if REGISTRATIONDIALOGS
			wf.MessageBox.Show("In SnapReg.Register(). Adding main keys");
#endif

			RegistryKey key =
                Registry.LocalMachine.OpenSubKey("Software\\Microsoft\\MMC\\Snapins", true);
            RegistryKey keyMMCNodeTypes =
                Registry.LocalMachine.OpenSubKey(NodeTypeGuidAttribute.DefaultNodeTypeRegKey, true);

            foreach(SnapinRegInfo snapin in fSnapinRegInfos)
            {
                key = key.CreateSubKey(snapin.fGUID);

                // the name 
                key.SetValue("NameString", snapin.fAttrib.Namestring);

#if REGISTRATIONDIALOGS
				wf.MessageBox.Show("In SnapReg.Register(). Added: " + snapin.fAttrib.Namestring);
#endif

				// the CLSID for the ISnapinAbout implementation
                key.SetValue("About", snapin.fAboutReg.fGUID);

                // the snadalone attribute
                if (snapin.fAttrib.StandAlone)
                    key.CreateSubKey("StandAlone");

                // for each NodeType key, create two entries:
                //   1. HKLM\Software\Microsoft\MMC\SnapIns\{snapin-GUID}\NodeTypes\{nodeTypeGuid}
                //       note: the "{snapin-GUID}" subkey was just created above
                //
                //   2. HKLM\Software\Microsoft\MMC\NodeTypes\{nodeTypeGuid}
                //
                if (snapin.aryNodeTypes.Length > 0)
                {
                    RegistryKey keySnapinNodeTypes = key.CreateSubKey("NodeTypes");
                    foreach (NodeTypeGuidAttribute nodeTypeAttribute in snapin.aryNodeTypes)
                    {
                        Guid nodeType = nodeTypeAttribute.NodeType;
                        String nodeTypeString = nodeType.ToString("B");

                        // HKLM\Software\Microsoft\MMC\SnapIns\{snapin-GUID}\NodeTypes\{nodeTypeGuid}
                        //
                        keySnapinNodeTypes.CreateSubKey(nodeTypeString);

                        RegistryKey keyMMCNodeTypesTemp = keyMMCNodeTypes;
                        String customNodeTypesKey = nodeTypeAttribute.CustomNodeTypeRegKey;
                        if (null != customNodeTypesKey)
                        {
                            keyMMCNodeTypesTemp =
                                Registry.LocalMachine.OpenSubKey(customNodeTypesKey, true);

                        }
                        // unless overridden by a custom key, this is
                        // HKLM\Software\Microsoft\MMC\NodeTypes\{nodeTypeGuid}
                        //
                        keyMMCNodeTypesTemp.CreateSubKey(nodeTypeString);
                    }
                }

				// for each ExtendsSnapin key, add an extension entry to the given key
				if (snapin.aryExtendNodeTypes.Length > 0)
				{
					foreach(ExtendsNodeAttribute extendsNodeAttribute in snapin.aryExtendNodeTypes)
					{
						Guid guidExtendedNode = extendsNodeAttribute.GuidOfExtendedNode;
						string sguidExtendedNode = guidExtendedNode.ToString("B");

                        RegistryKey keyMMCNodeTypesTemp = keyMMCNodeTypes;
                        String customNodeTypesKey = extendsNodeAttribute.CustomNodeTypeRegKey;
                        if (null != customNodeTypesKey)
                        {
                            keyMMCNodeTypesTemp =
                                Registry.LocalMachine.CreateSubKey(customNodeTypesKey);

                        }
						// open or create the key for the designated that is being extended
						RegistryKey keySnapinNode = keyMMCNodeTypesTemp.CreateSubKey(sguidExtendedNode);

						// open or create the extensions sub key
						RegistryKey keyExtensions = keySnapinNode.CreateSubKey("Extensions");

						// open or create the appropriate sub key to that
						string ssubkey=extendsNodeAttribute.ExtensionTypeSubkey;
						RegistryKey keyExtensionType = keyExtensions.CreateSubKey(ssubkey);

						// finally, add a value indicating the GUID of the snapin and its description
						keyExtensionType.SetValue(snapin.fGUID, snapin.fAttrib.Namestring);
					}
				}

            }
        }

		void UnRegister()
		{
			try
			{
                RegistryKey key =
                    Registry.LocalMachine.OpenSubKey("Software\\Microsoft\\MMC\\Snapins", true);
                RegistryKey keyMMCNodeTypes =
                    Registry.LocalMachine.OpenSubKey("Software\\Microsoft\\MMC\\NodeTypes", true);

                foreach(SnapinRegInfo snapin in fSnapinRegInfos)
			    {        
					key.DeleteSubKeyTree(snapin.fGUID);

                    // for each NodeType key, remove the entry from
                    //   HKLM\Software\Microsoft\MMC\NodeTypes\{nodeTypeGuid}
                    //
                    // ... unless the DontRegisterNodeType flag is set.  In this case,
                    // we'll leave the key in the registry.  This flag being set
                    // indicates that the node type wasn't registered by our app, so we
                    // shouldn't remove it.
                    //
                    foreach (NodeTypeGuidAttribute nodeTypeAttribute in snapin.aryNodeTypes)
                    {
                        if (nodeTypeAttribute.DontUnregisterNodeType)
                        {
                            continue;
                        }

                        Guid nodeType = nodeTypeAttribute.NodeType;
                        String nodeTypeString = nodeType.ToString("B");

                        // HKLM\Software\Microsoft\MMC\NodeTypes\{nodeTypeGuid}
                        //
                        keyMMCNodeTypes.DeleteSubKeyTree(nodeTypeString);
                    }

					// for each ExtendsSnapin key, remove an extension entry from the given key
					foreach(ExtendsNodeAttribute extendsNodeAttribute in snapin.aryExtendNodeTypes)
					{
						Guid guidExtendedNode = extendsNodeAttribute.GuidOfExtendedNode;
						string sguidExtendedNode = guidExtendedNode.ToString("B");

						// open the key for the node that is being extended
						RegistryKey keySnapinNode = keyMMCNodeTypes.OpenSubKey(sguidExtendedNode);

						// open the extensions sub key
						RegistryKey keyExtensions = keySnapinNode.OpenSubKey("Extensions");

						// open the appropriate sub key to that
						string ssubkey=extendsNodeAttribute.ExtensionTypeSubkey;
						RegistryKey keyExtensionType = keyExtensions.OpenSubKey(ssubkey, true);

						// finally, delete the value indicating the GUID of the snapin and its description
						keyExtensionType.DeleteValue(snapin.fGUID);
					}                
				}
			}
            catch(ArgumentException)
            {
            }
            catch (System.Security.SecurityException)
            {
            }
		}
    }
}
