using System;
using System.Runtime.InteropServices;

using Ironring.Management.MMC;

namespace MMCTest
{
	//Added by Wojciech Sobocinski
	/// <summary>
	/// Using this node to allow ANY node type to be dragged onto it, unless the nide is a direct child
	/// </summary>
	public class MyRootNode : BaseNode
	{
		public MyRootNode(SnapinBase snapin) : base(snapin)
		{
			//
			// TODO: Add constructor logic here
			//
		}

		//Added by Wojciech Sobocinski
		public override bool OnQueryPaste(IDataObject ido)
		{
			BaseNode nodeToBePasted = ((Ironring.Management.MMC.DataObject)ido).Node;
			//
			// some checks to prevent same node copy
			//
			return (nodeToBePasted.HScopeItem != this.HScopeItem &&  // don't paste on ourselves
					nodeToBePasted.HScopeItem != this.ParentHScopeItem && // dont paste our parent onto us
					nodeToBePasted.ParentHScopeItem != this.HScopeItem); // and finally don't paste if they are already a child
		}


		//Added by Wojciech Sobocinski
		public override bool OnPaste(IDataObject ido)
		{
			BaseNode nodeToBePasted = ((Ironring.Management.MMC.DataObject)ido).Node;

							
			//node.Remove(false);  * calling this causes a trap when inserting back with an invalid handle

			//
			// so we will do it manually
			//

			Snapin.ConsoleNameSpace.DeleteItem((uint)nodeToBePasted.HScopeItem, 1);

			//
			// need to remove from parent child
			//
			BaseNode parent = nodeToBePasted.ParentNode;
			parent.Children.Remove(nodeToBePasted);
			this.AddChild(nodeToBePasted);
			nodeToBePasted.Insert(this);
			
			return true;
		}

		//Added by Wojciech Sobocinski
		public override void OnSelectScope()
		{
			// In the root node we only want to allow a paste
			SetVerbState(MMC_CONSOLE_VERB.PASTE, MMC_BUTTON_STATE.ENABLED, true);

			base.OnSelectScope ();
		}

		
	
		public override void OnQueryProperties()
		{
			// TODO:  Add MyRootNode.OnQueryProperties implementation
			System.Windows.Forms.MessageBox.Show("OnQueryProperties");
			base.OnQueryProperties ();
		}
	}
}
