Imports Ironring.Management.MMC

Public Class MyBaseNode
    Inherits BaseNode

    'for creating PropertyPages
    Protected lpProvider As IPropertySheetCallback
    Protected hanlder As IntPtr

#Region "Default ctor"
    Sub New(ByVal snapin As SnapinBase)
        MyBase.New(snapin)
    End Sub

    Sub New(ByVal snapin As SnapinBase, ByVal parentNode As BaseNode)
        MyBase.New(snapin, parentNode)
    End Sub
#End Region

#Region "Initialize"
    Public Overrides Sub Initialize()
        MyBase.Initialize()

        'Init Node
        InitNode()

        'Init Child Nodes
        InitChildNodes()

        'Menu Items
        InitNodeMenuItems()

        'Property Pages
        InitNodePropertyPages()
    End Sub
    Protected Overridable Sub InitNode()
    End Sub
    Protected Overridable Sub InitChildNodes()
    End Sub
    Protected Overridable Sub InitNodeMenuItems()
    End Sub
    Protected Overridable Sub InitNodePropertyPages()
    End Sub
#End Region

    Private Sub Node_OnQueryPropertiesEvent(ByVal sender As Object, ByVal args As Ironring.Management.MMC.NodeEventArgs) Handles MyBase.OnQueryPropertiesEvent
        Me.EditMode = True
    End Sub

    Private Sub Node_OnUserEvent(ByVal sender As Object, ByVal args As Ironring.Management.MMC.NodeEventArgs) Handles MyBase.OnUserEvent
        Dim e As NameValueArgs = DirectCast(args, NameValueArgs)
        Dim node As BaseNode = DirectCast(e.Val, BaseNode)

        '---destroy all children 
        If EditMode Then
            OnRename(node.DisplayName)
        Else
            ParentNode.AddChild(Me)
            node.Insert(ParentNode)

            Snapin.ResultViewConsole.SelectScopeItem(node.HScopeItem)
            Snapin.ConsoleNameSpace.Expand(Convert.ToUInt32(node.HScopeItem))
        End If
    End Sub

    Private Sub Node_OnDeleteEvent(ByVal sender As Object, ByVal args As Ironring.Management.MMC.NodeEventArgs) Handles MyBase.OnDeleteEvent
        Dim selNode As BaseNode = CType(sender, BaseNode)

        '---checkpoint
        Trace.WriteLine(String.Format("OnDeleteEvent: sender={0}", selNode.DisplayName))

        '---delete node and its children
        'selNode.Snapin.ConsoleNameSpace.DeleteItem(Convert.ToUInt32(selNode.HScopeItem), 1)
        selNode.Remove(False)
    End Sub

    Public Overrides Function OnRename(ByVal newName As String) As Boolean
        DisplayName = newName
        Return True
    End Function

    Public Property ConsoleVerb(ByVal cmd As MMC_CONSOLE_VERB) As Boolean
        Get
            Return MyBase.GetVerbState(cmd, MMC_BUTTON_STATE.ENABLED)
        End Get
        Set(ByVal Value As Boolean)
            SetVerbState(cmd, MMC_BUTTON_STATE.ENABLED, Value)
        End Set
    End Property
End Class

