Imports System
Imports System.Runtime.InteropServices

Imports Ironring.Management.MMC

Public Class MyReportNode
    Inherits ReportNode

    'for creating PropertyPages
    Protected lpProvider As IPropertySheetCallback
    Protected hanlder As IntPtr

    Protected _selectedRowID As Integer
    Public Property SelectedRowID() As Integer
        Get
            Return _selectedRowID
        End Get
        Set(ByVal Value As Integer)
            _selectedRowID = Value
        End Set
    End Property

#Region "Default ctor"
    Sub New(ByVal snapin As SnapinBase)
        MyBase.New(snapin)
    End Sub

    Sub New(ByVal snapin As SnapinBase, ByVal parentNode As BaseNode)
        MyBase.New(snapin, parentNode)
    End Sub
#End Region

#Region "Initialize"
    Public Overrides Sub Initialize()
        MyBase.Initialize()

        'InitImages
        InitResultViewImages()

        'Init Node
        InitNode()

        'Init Child Nodes
        InitChildNodes()

        'Menu Items
        InitNodeMenuItems()

        'Property Pages
        InitNodePropertyPages()

        'Init Data
        InitData()
    End Sub

    Protected Overridable Sub InitResultViewImages()
    End Sub
    Protected Overridable Sub InitNode()
    End Sub
    Protected Overridable Sub InitChildNodes()
    End Sub
    Protected Overridable Sub InitNodeMenuItems()
    End Sub
    Protected Overridable Sub InitNodePropertyPages()
    End Sub
    Protected Overridable Sub InitData()
    End Sub
#End Region

    Private Sub Node_OnQueryPropertiesEvent(ByVal sender As Object, ByVal args As Ironring.Management.MMC.NodeEventArgs) Handles MyBase.OnQueryPropertiesEvent
        SelectedRowID = GetTableRowID(SelectedItem.lParam)
        Me.EditMode = True
    End Sub

    Private Sub Node_OnUserEvent(ByVal sender As Object, ByVal args As Ironring.Management.MMC.NodeEventArgs) Handles MyBase.OnUserEvent
        Dim e As NameValueArgs = DirectCast(args, NameValueArgs)
        Dim node As ReportNode = Me
        Dim row As DataRow = DirectCast(e.Val, DataRow)

        '---destroy all children 
        If EditMode Then
            'OnRename(node.DisplayName)
            Dim lParam As Integer = m_iCookie Or (_selectedRowID << 16)
            Dim pItemID As UInt32

            ResultData.FindItemByLParam(lParam, pItemID)
            ResultData.UpdateItem(pItemID)
        Else
            'ParentNode.AddChild(Me)
            node.InsertItem(row, node.Table.Rows.Count)

            'Snapin.ResultViewConsole.SelectScopeItem(node.HScopeItem)
            'Snapin.ConsoleNameSpace.Expand(Convert.ToUInt32(node.HScopeItem))
        End If

        'Dim pDO As IDataObject
        'Snapin.QueryDataObject(Cookie, Convert.ToUInt32(CCT.RESULT), pDO)
        'Snapin.ResultViewConsole.UpdateAllViews(pDO, 0, 0)
    End Sub

    Public Property ConsoleVerb(ByVal cmd As MMC_CONSOLE_VERB) As Boolean
        Get
            Return MyBase.GetVerbState(cmd, MMC_BUTTON_STATE.ENABLED)
        End Get
        Set(ByVal Value As Boolean)
            SetVerbState(cmd, MMC_BUTTON_STATE.ENABLED, Value)
        End Set
    End Property

    Protected ReadOnly Property SelectedItem() As RESULTDATAITEM
        Get
            Return GetSelectedItem()
        End Get
        'Set(ByVal Value As RESULTDATAITEM)
        'tbd = value
        'End Set
    End Property

    Private Sub MyReportNode_OnDeleteEvent(ByVal sender As Object, ByVal args As Ironring.Management.MMC.NodeEventArgs) Handles MyBase.OnDeleteEvent
        Dim rdi As RESULTDATAITEM = GetSelectedItem()
        Dim nRow As Integer

        While rdi.nIndex <> -1
            nRow = GetTableRowID(rdi.lParam)

            Table.Rows(nRow).Delete()
            DeleteItem(rdi.lParam)

            rdi = GetSelectedItem()
        End While
    End Sub

    Public Overrides Property Guid() As Guid
        Get
            Dim attrs() As Object = Me.GetType.GetCustomAttributes(GetType(GuidAttribute), True)

            If (attrs.Length = 0) Then
                Throw New SnapinException("Failed ot find GuidAttribute on Node class")
            End If

            Return New Guid(CType(attrs(0), GuidAttribute).Value)
        End Get
        Set(ByVal Value As Guid)
            m_guid = Value
        End Set
    End Property
End Class

