/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */

#pragma once

typedef CAtlMap<HKEY, UINT> RegistryLieMap;

class RegLieManager
{
public:
    RegLieManager(void);
    ~RegLieManager(void);


    BOOL HandleRegOpenExW(HKEY hKey,
                          LPCWSTR lpSubKey,
                          DWORD ulOptions,
                          REGSAM samDesired,
                          REG_OPEN_KEY_EXW_API_PTR lpRealRegOpenKeyExW,
                          PHKEY phkLieResult,
                          PLONG plLieReturnValue);

    void HandleRegClose(HKEY hKey);

    BOOL HandleRegEnumValueW(HKEY hKey,
                             DWORD dwIndex,
                             LPWSTR lpValueName,
                             LPDWORD lpcbValueName,
                             LPDWORD lpReserved,
                             LPDWORD lpType,
                             LPBYTE lpData,
                             LPDWORD lpcbData,
                             PLONG plLieReturnValue);

    void SetShouldLie(BOOL fShouldLie);

    HRESULT PopulateFakeNodeType();

    HRESULT EnablePermissiveRegistryKeys();

    HRESULT CleanupCenterisNodeTypes();


protected:
    // TODO: add some sort of synchronization to this shizzle...
    //
    RegistryLieMap m_LieMap;
    BOOL m_fShouldLie;

    static const HKEY s_hkeyRootReal;
    static LPCWSTR s_pwszReal;
    static const UINT s_cchReal;

    static const HKEY s_hkeyRootCenteris;
    static LPCWSTR s_pwszCenteris;

    static LPCWSTR s_pwszCrossPolinationNodeTypeGuid;
    static LPCWSTR s_pwszComputerManagementSnapinGuid;

    static const HKEY s_hkeyFalseNodeRoot;
    static LPCWSTR s_pwszFalseNodeTypeInWindows;
    static LPCWSTR s_pwszFalseNodeTypeInCenteris;

};
