/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */



#include "stdafx.h"

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include "regwalk.h"


//
// Note - you must open up hkeys to the source and destination that you
// to copy the keys to.
//

void CopyRegKeyNames ( HKEY hKeyRoot, LPCWSTR pwszSubkey, HKEY hKeyDest)
{
    HKEY hKeyTemp = 0;
    // open the subkey, if we can
    //
    LONG lResult = ::RegOpenKeyExW(hKeyRoot,     // handle for base key
                                   pwszSubkey,   // subkey name string
                                   0,                 // options, must be 0
                                   KEY_READ,          // desired access rights
                                   &hKeyTemp); // handle to newly opened subkey
    if (ERROR_SUCCESS == lResult)
    {
        // copy all the extensions of this nodetype into the "centeris" nodetype
        //
        CopyRegKeyNames(hKeyTemp, hKeyDest);

        ::RegCloseKey(hKeyTemp);
    }
}

void CopyRegKeyNames( HKEY hEnumKey, HKEY hCopyKey )
{
  WCHAR szReturnBuff[MAX_KEY_LEN] ;
  long lKeyIndex, lReturnCode ;

//
//  call the copy value section here.
//

  CopyRegKeyValues(hEnumKey, hCopyKey) ; // copy all the values in this key...


  lKeyIndex = 0 ;
  do
  {
    DWORD cchReturnBuffLen=sizeof(szReturnBuff)/sizeof(szReturnBuff[0]);

    FILETIME ftLastWriteTime;                      // last write time
    lReturnCode = RegEnumKeyExW(hEnumKey,
                                lKeyIndex,         // index of subkey
                                szReturnBuff,      // & to subkey name
                                &cchReturnBuffLen, // & to subkey len, in chars
                                NULL,              // reserved
                                NULL,              // & to class name str
                                NULL,              // & to len of class name
                                &ftLastWriteTime ) ;       // & for time last written

    if(lReturnCode == ERROR_SUCCESS )
    {
        HKEY hTmpDest ;
        if (RegCreateKeyExW(hCopyKey      // Try and create within the copy key.
                          , szReturnBuff            // subkey
                          , 0                       // must be 0
                          , NULL                    // str for class. ignore if exis
                          , 0                       // REG_OPTION_NON_VOLTIAL is def
                          , KEY_ALL_ACCESS          // access method
                          , NULL                    // ptr to security attrib.
                          , &hTmpDest               // handle for key
                          , NULL )
                                             == ERROR_SUCCESS )
        {
            cchReturnBuffLen=sizeof(szReturnBuff)/sizeof(szReturnBuff[0]);

            HKEY hTmpSrc;
            if (RegOpenKeyExW(hEnumKey     // use current open key
                            , szReturnBuff         // the next enum subkey
                            , 0                    // must be 0
                            , KEY_READ             // query type, includes enumkeys
                            , &hTmpSrc )               
                                         == ERROR_SUCCESS )
            {
                CopyRegKeyNames( hTmpSrc, hTmpDest  ) ; //try again
                RegCloseKey(hTmpSrc);
          }

          RegCloseKey(hTmpDest) ;
       } // of if regcreate

     }

   lKeyIndex++ ;  // try the next subkey

  } while( lReturnCode == ERROR_SUCCESS ) ;  // do while we have keys left

} // of CopyRegKeyNames() 




void CopyRegKeyValues( HKEY hEnumValue, HKEY hCopyValue )
{
  
  WCHAR szReturnBuff[MAX_KEY_LEN];
  BYTE arybDataBuff[MAX_KEY_LEN * sizeof(WCHAR)] ;
  long lKeyIndex, lReturnCode ;

  lKeyIndex = 0 ;  
  do
  {
    DWORD cchReturnBuffLen=sizeof(szReturnBuff)/sizeof(szReturnBuff[0]);

    DWORD dwType ;
    DWORD dwDataSize = sizeof(arybDataBuff) ;

    lReturnCode = RegEnumValueW(hEnumValue,
                                lKeyIndex,        // index of subkey
                                szReturnBuff,     // & to subkey name
                                &cchReturnBuffLen,// & to subkey len, in chars
                                NULL,             // reserved
                                &dwType,          // & of buff for type code
                                arybDataBuff,     // & of buff for value data
                                &dwDataSize  ) ;              // & for size of data

    if(lReturnCode == ERROR_SUCCESS )
     {
       if (RegSetValueExW( hCopyValue              // Try and create the copy key.
                         , szReturnBuff            // subkey
                         , 0                       // must be 0, reserved.
                         , dwType                  // type of data
                         , arybDataBuff            // data value
                         , dwDataSize )            // size of data type.
                                            != ERROR_SUCCESS )
       {
         printf("\n\nError - Can not set value %s\n\n",szReturnBuff );
       }// of if setvalue
     } 

   lKeyIndex++ ;  // try the next subkey

  } while( lReturnCode == ERROR_SUCCESS ) ;  // do while we have keys left
   
} // of CopyRegKeyNames() 














