/*
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at 
 * http://www.opensource.org/licenses/cddl1.php
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the original License file at src/license.txt.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[ ]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 *
 * Copyright (c) 2005 by Centeris, Inc.  All rights reserved.
 * Use is subject to license terms.
 * Initial Developer updates, news, and information may be found at 
 * http://sourceforge.net/projects/likewiseopenagt
 */





#ifndef _INC_SPOOF_REG_
#define _INC_SPOOF_REG_


#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#ifdef __cplusplus
  extern "C" {
#endif



//
// Here is a list of the signatures of the registry functions that we want to hook. We'll
// be getting the real entry points for these functions and track them inside of
// our spoofed functions so that we can call them when we need to.
//

typedef LONG (APIENTRY *REG_OPEN_KEYA_API_PTR)(HKEY,LPCSTR,PHKEY) ;

typedef LONG (APIENTRY *REG_OPEN_KEYW_API_PTR)(HKEY, LPCWSTR, PHKEY) ;

typedef LONG (APIENTRY *REG_OPEN_KEY_EXA_API_PTR)(HKEY,LPCSTR, DWORD, REGSAM, PHKEY) ;

typedef LONG (APIENTRY *REG_OPEN_KEY_EXW_API_PTR)(HKEY, LPCWSTR, DWORD, REGSAM, PHKEY);

typedef LONG (APIENTRY *REG_CREATE_KEYA_API_PTR)(HKEY, LPCSTR, PHKEY) ;

typedef LONG (APIENTRY *REG_CREATE_KEYW_API_PTR)(HKEY, LPCWSTR, PHKEY) ;

typedef LONG (APIENTRY *REG_CREATE_KEY_EXA_API_PTR)(HKEY, LPCSTR, DWORD, LPSTR, DWORD, REGSAM, LPSECURITY_ATTRIBUTES, PHKEY, LPDWORD );

typedef LONG (APIENTRY *REG_CREATE_KEY_EXW_API_PTR)(HKEY, LPCWSTR, DWORD, LPWSTR, DWORD, REGSAM, LPSECURITY_ATTRIBUTES, PHKEY, LPDWORD ) ;

typedef LONG (APIENTRY *REG_CLOSE_KEY_API_PTR)(HKEY);

typedef LONG (APIENTRY *REG_ENUM_VALUEA_API_PTR)(HKEY, DWORD, LPSTR, LPDWORD, LPDWORD, LPDWORD, LPBYTE, LPDWORD ) ;

typedef LONG (APIENTRY *REG_ENUM_VALUEW_API_PTR)(HKEY, DWORD, LPWSTR, LPDWORD, LPDWORD, LPDWORD, LPBYTE, LPDWORD ) ;



//
// function fowards
//

LONG APIENTRY SpoofedRegOpenKeyA(HKEY,LPCSTR,PHKEY) ;

LONG APIENTRY SpoofedRegOpenKeyW(HKEY,LPCWSTR,PHKEY) ;

LONG APIENTRY SpoofedRegOpenKeyExA(HKEY,LPCSTR,DWORD,REGSAM,PHKEY) ;

LONG APIENTRY SpoofedRegOpenKeyExW(HKEY,LPCWSTR,DWORD,REGSAM,PHKEY) ;

LONG APIENTRY SpoofedRegCreateKeyA(HKEY, LPCSTR, PHKEY) ;

LONG APIENTRY SpoofedRegCreateKeyW(HKEY, LPCWSTR, PHKEY) ;

LONG APIENTRY SpoofedRegCreateKeyExA(HKEY,LPCSTR,DWORD,LPSTR,DWORD,REGSAM,LPSECURITY_ATTRIBUTES,PHKEY,LPDWORD) ;

LONG APIENTRY SpoofedRegCreateKeyExW(HKEY,LPCWSTR,DWORD,LPWSTR,DWORD,REGSAM,LPSECURITY_ATTRIBUTES,PHKEY,LPDWORD) ;

LONG APIENTRY SpoofedRegCloseKey(HKEY) ;

LONG APIENTRY SpoofedRegEnumValueA(HKEY,DWORD,LPSTR,LPDWORD,LPDWORD,LPDWORD,LPBYTE,LPDWORD);

LONG APIENTRY SpoofedRegEnumValueW(HKEY,DWORD,LPWSTR,LPDWORD,LPDWORD,LPDWORD,LPBYTE,LPDWORD);


#ifdef __cplusplus
}
#endif

DWORD HookMmcRegistryCalls();

DWORD UnhookMmcRegistryCalls();

HRESULT EnablePermissiveRegistryKeys();

HRESULT CleanupCenterisNodeTypes();

class RegLieManager;
extern RegLieManager* g_pLieManager;



#endif // of _INC_SPOOF_REG_



